/********************************* Class Declaration ***************************/
/**
\package  _uc_MediaPlayer - 
\class    OMediaPlayer (Build: 210)

\brief    


\date     $Date: 2011-10-26 13:41:03.62 $
\note     dbsource gui.dev - ODABA Version 11.2.0

          Copyright (C) 1994-2011 Run Software GmbH.
 
          This program is free software: you can redistribute it and/or modify
          it under the terms of the GNU General Public License as published by
          the Free Software Foundation, either version 3 of the License, or
          (at your option) any later version.
 
          This program is distributed in the hope that it will be useful,
          but WITHOUT ANY WARRANTY; without even the implied warranty of
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
          GNU General Public License 3.0 for more details.
 
          You should have received a copy of the GNU General Public License
          along with this program. If not, see <http://www.gnu.org/licenses/>.

*/
/******************************************************************************/
#pragma once
class OMediaPlayer;

class OVideoWidget;
class QAction;
class QComboBox;
class QHBoxLayout;
class QLabel;
class QSlider;
class QString;
class QTextEdit;
class QToolBar;
class QVBoxLayout;
class QWidget;
#include  <h/cqt.h>
class  OMediaPlayer    : public QObject                                           ,
public UserControl                                       
{


private    :                                                       Q_OBJECT;                                                 // 
protected  :         bool                                          fullscreen;                                               // 
protected  :         OVideoWidget                                * videoWidget;                                              // 
protected  :         QSlider                                     * sliderHue;                                                // 
protected  :         QComboBox                                   * aspectRatioComboBox;                                      // 
protected  :         QSlider                                     * sliderContrast;                                           // 
protected  :         QSlider                                     * sliderSaturation;                                         // 
protected  :         QSlider                                     * sliderBrightness;                                         // 
protected  :         ::QWidget                                   * videoOptionsPanel;                                        // 
protected  :         ::QWidget                                   * panel;                                                    // 
protected  :         Phonon::Path                                  audioPath;                                                // 
protected  :         QLabel                                      * labelTime_length;                                         // 
protected  :         QLabel                                      * labelTime_position;                                       // 
protected  :         QProgressBar                                * progressBar;                                              // 
protected  :         QAction                                     * actionFullScreen;                                         // 
protected  :         QAction                                     * actionNext;                                               // 
protected  :         QAction                                     * actionVideoOptions;                                       // 
protected  :         QAction                                     * actionPrevious;                                           // 
protected  :         QAction                                     * actionReinitAudio;                                        // 
protected  :         QAction                                     * actionBackward;                                           // 
protected  :         QAction                                     * actionForward;                                            // 
protected  :         QAction                                     * actionRepeat;                                             // 
protected  :         QAction                                     * actionPause;                                              // 
protected  :         QAction                                     * actionStop;                                               // 
protected  :         QAction                                     * actionStart;                                              // 
protected  :         QTextEdit                                   * audioInfoBox;                                             // 
protected  :         QHBoxLayout                                 * layout_time;                                              // 
protected  :         QVBoxLayout                                 * layout;                                                   // 
protected  :         QToolBar                                    * toolbar;                                                  // 
protected  :         Phonon::VolumeSlider                        * volumeSlider;                                             // 
protected  :         Phonon::SeekSlider                          * seekSlider;                                               // 
protected  :         Phonon::MediaObject                         * mediaObject;                                              // 
protected  :         Phonon::AudioOutput                         * audioOutput;                                              // 
protected  :         logical                                       busy;                                                     // 

public     :
                     QAction                                     * get_actionFullScreen() { return(actionFullScreen); }
                     QAction                                     * get_actionNext() { return(actionNext); }
                     QAction                                     * get_actionVideoOptions() { return(actionVideoOptions); }
                     QAction                                     * get_actionPrevious() { return(actionPrevious); }
                     QAction                                     * get_actionReinitAudio() { return(actionReinitAudio); }
                     QAction                                     * get_actionBackward() { return(actionBackward); }
                     QAction                                     * get_actionForward() { return(actionForward); }
                     QAction                                     * get_actionRepeat() { return(actionRepeat); }
                     QAction                                     * get_actionPause() { return(actionPause); }
                     QAction                                     * get_actionStop() { return(actionStop); }
                     QAction                                     * get_actionStart() { return(actionStart); }
                     logical                                       get_busy() { return(busy); }
public     :                                            OMediaPlayer (UserControlHandle *pUserControlHandle, ::QWidget *parent );
public     :  virtual                              void clearData ( );
public     :                                       void enqueueFile (const ::QString &rcQString );
public     :  virtual                              void fillData ( );
public     :                                       void initActions ( );
public     :                                       ::QWidget *initVideoOptionsPanel (::QWidget *parent );
protected  :  private slots:                       void moSlot_aboutToFinish ( );
protected  :  private slots:                       void moSlot_metaDataChanged ( );
protected  :  private slots:                       void moSlot_stateChanged (Phonon::State oldPhononState, Phonon::State newPhononState );
protected  :  private slots:                       void moSlot_tick (qint64 qi64Time );
protected  :  private slots:                       void moSlot_totalTimeChanged (qint64 qi64Time );
public     :                                       void refreshProgressLabel (QLabel &rQLabel, qint64 qi64Time );
protected  :  private slots:                       void slot_aspectComboIndexChanged (int pos );
protected  :  private slots:                       void slot_backward ( );
protected  :  private slots:                       void slot_forward ( );
protected  :  private slots:                       void slot_next ( );
protected  :  private slots:                       void slot_pause ( );
protected  :  private slots:                       void slot_previous ( );
protected  :  private slots:                       void slot_reinitAudio ( );
protected  :  private slots:                       void slot_repeat ( );
protected  :  private slots:                       void slot_start ( );
protected  :  private slots:                       void slot_stop ( );
protected  :  private slots:                       void slot_toggleFullScreen ( );
protected  :  private slots:                       void slot_toggleVideoOptions ( );
public     :                                       void startFile (const ::QString &rcQString );
protected  :  private slots:                       void voSlot_brightness (int iPosition );
protected  :  private slots:                       void voSlot_contrast (int iPosition );
protected  :  private slots:                       void voSlot_hue (int iPosition );
protected  :  private slots:                       void voSlot_saturation (int iPosition );
public     :  virtual                              ::QWidget *widget ( );
public     :                                            ~OMediaPlayer ( );

};

