/********************************* Class Source Code ***************************/
/**
\package  _uc_MediaPlayer - 
\class    OMediaPlayer (Build: 211)

\brief    


\date     $Date: 2011-10-26 13:41:19.60 $
\note     dbsource gui.dev - ODABA Version 11.2.0

          Copyright (C) 1994-2011 Run Software GmbH.
 
          This program is free software: you can redistribute it and/or modify
          it under the terms of the GNU General Public License as published by
          the Free Software Foundation, either version 3 of the License, or
          (at your option) any later version.
 
          This program is distributed in the hope that it will be useful,
          but WITHOUT ANY WARRANTY; without even the implied warranty of
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
          GNU General Public License 3.0 for more details.
 
          You should have received a copy of the GNU General Public License
          along with this program. If not, see <http://www.gnu.org/licenses/>.

*/
/******************************************************************************/
#define    OBJ_ID  "OMediaPlayer"

#include  <h/p_uc_MediaPlayer.h>
#include  <h/icons.rcc>
#include  <h/OMediaPlayer.moc>
#include  <h/OVideoWidget.hpp>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/OMediaPlayer.hpp>



































/**************************************************************************//**
\brief  OMediaPlayer - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "OMediaPlayer"

/**************************************************************************//**
\brief  OMediaPlayer - 
*******************************************************************************
\brief  default - 



\param  pUserControlHandle - 
\param  parent - 
*******************************************************************************
******************************************************************************/

     OMediaPlayer :: OMediaPlayer (UserControlHandle *pUserControlHandle, ::QWidget *parent )
                     : QObject(),
UserControl(pUserControlHandle),
  fullscreen(false),
  videoWidget(NULL),
  sliderHue(NULL),
  aspectRatioComboBox(NULL),
  sliderContrast(NULL),
  sliderSaturation(NULL),
  sliderBrightness(NULL),
  videoOptionsPanel(NULL),
  panel(NULL),
  audioPath(),
  labelTime_length(NULL),
  labelTime_position(NULL),
  progressBar(NULL),
  actionFullScreen(),
  actionNext(),
  actionVideoOptions(),
  actionPrevious(),
  actionReinitAudio(),
  actionBackward(),
  actionForward(),
  actionRepeat(),
  actionPause(),
  actionStop(),
  actionStart(),
  audioInfoBox(NULL),
  layout_time(NULL),
  layout(NULL),
  toolbar(NULL),
  volumeSlider(NULL),
  seekSlider(NULL),
  mediaObject(NULL),
  audioOutput(NULL),
  busy()
{

	panel= new QWidget( parent );

	toolbar= new QToolBar( panel );
	toolbar->resize( 200, 24 );
	toolbar->setIconSize( QSize( 18, 18 ) );

	mediaObject= new Phonon::MediaObject( this );
	audioOutput= new Phonon::AudioOutput( Phonon::MusicCategory, this );
	
	videoWidget = new OVideoWidget( panel );
	videoWidget->setSizePolicy( QSizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding ) );
	videoWidget->hide();
	//videoWidget->setFocusProxy( panel );
	
	seekSlider = new Phonon::SeekSlider( panel );
	seekSlider->setMediaObject( mediaObject );

	volumeSlider = new Phonon::VolumeSlider( toolbar );
	volumeSlider->setMaximumWidth( 125 );
	volumeSlider->setMinimumWidth( 25 );
	volumeSlider->setAudioOutput( audioOutput );

	Phonon::createPath( mediaObject, videoWidget );
	audioPath.reconnect( mediaObject, audioOutput );
	
     	
	audioInfoBox= new QTextEdit( panel );
	audioInfoBox->setFont( QFont( "Arial", 10 ) );
//	audioInfoBox->hide();
	
	labelTime_position= new QLabel( panel );
	labelTime_position->setFont( QFont( "Arial", 10 ) );
	labelTime_position->setText( "00:00:00" );
	labelTime_position->resize( 75, 24 );
	
	labelTime_length= new QLabel( panel );
	labelTime_length->setFont( QFont( "Arial", 10 ) );
	labelTime_length->setText( "00:00:00" );
	labelTime_length->resize( 75, 24 );


	connect( mediaObject, SIGNAL( aboutToFinish() ), this, SLOT( moSlot_aboutToFinish() ) );
	connect( mediaObject, SIGNAL( tick( qint64 ) ), this, SLOT( moSlot_tick( qint64 ) ) );
	connect( mediaObject, SIGNAL( totalTimeChanged( qint64 ) ), this, SLOT( moSlot_totalTimeChanged( qint64 ) ) );
	connect( mediaObject, SIGNAL( metaDataChanged() ), this, SLOT( moSlot_metaDataChanged() ) );
	connect( videoWidget, SIGNAL( doubleLeftClick() ), this, SLOT( slot_toggleFullScreen() ) );
	
	//connect( mediaObject, SIGNAL( stateChanged( Phonon::State, Phonon::State ) ), this, SLOT( mirSlot_stateChanged( Phonon::State, Phonon::State ) ) );
	//void 	currentSourceChanged ( const Phonon::MediaSource & newSource )
	
	initActions();	
	
	layout = new QVBoxLayout();
	layout->setSpacing( 0 );
	layout->setContentsMargins( 0, 0, 0, 0 );

	layout_time = new QHBoxLayout();
	layout_time->setSpacing( 0 );
	layout_time->setContentsMargins( 3, 3, 3, 3 );

	layout->addWidget( videoWidget );
	layout->addWidget( initVideoOptionsPanel( panel ) );
	layout->addWidget( audioInfoBox );

	layout->addWidget( toolbar );
	
	layout_time->addWidget( seekSlider );
	layout_time->addSpacing( 3 );
	layout_time->addWidget( labelTime_position );
	layout_time->addSpacing( 5 );
	layout_time->addWidget( labelTime_length );
	layout->addLayout( layout_time );
	
	panel->setLayout( layout );



}

/**************************************************************************//**
\brief  clearData - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "clearData"

/**************************************************************************//**
\brief  clearData - 
*******************************************************************************
\brief  i0 - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: clearData ( )
{



}

/**************************************************************************//**
\brief  enqueueFile - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "enqueueFile"

/**************************************************************************//**
\brief  enqueueFile - 
*******************************************************************************
\brief  default - 



\param  rcQString - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: enqueueFile (const ::QString &rcQString )
{
  QFileInfo fi(rcQString);

  if ( fi.exists() ) {
    mediaObject->enqueue(fi.absoluteFilePath());
  }


}

/**************************************************************************//**
\brief  fillData - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "fillData"

/**************************************************************************//**
\brief  fillData - 
*******************************************************************************
\brief  i0 - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: fillData ( )
{
  const void  *data  = control_handle->property()->value().toString().area();
	QString       value(static_cast<const char *>(data));

  if ( busy )
    enqueueFile(value);
  else
    startFile(value);	

}

/**************************************************************************//**
\brief  initActions - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "initActions"

/**************************************************************************//**
\brief  initActions - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: initActions ( )
{

	actionStart= new QAction( QIcon( ":/start.png" ), tr("&start"), this );
	actionStart->setShortcut( QKeySequence( tr( "Space" ) ) );
	connect( actionStart, SIGNAL( triggered() ), this, SLOT( slot_start() ) );

	actionPause= new QAction( QIcon( ":/pause.png" ), tr("p&ause"), this );
	actionPause->setShortcut( QKeySequence( tr( "Space" ) ) );
	connect( actionPause, SIGNAL( triggered() ), this, SLOT( slot_pause() ) );

	actionStop= new QAction( QIcon( ":/stop.png" ), tr("s&top"), this );
	actionStop->setShortcut( QKeySequence( tr( "Ctrl+t" ) ) );
	connect( actionStop, SIGNAL( triggered() ), this, SLOT( slot_stop() ) );

	actionRepeat= new QAction( QIcon( ":/repeat.png" ), tr("&repeat"), this );
	actionRepeat->setShortcut( QKeySequence( tr( "Ctrl+r" ) ) );
	connect( actionRepeat, SIGNAL( triggered() ), this, SLOT( slot_repeat() ) );

	actionForward= new QAction( QIcon( ":/forward.png" ), tr("&forward"), this );
	actionForward->setShortcut( QKeySequence( tr( "Ctrl+f" ) ) );
	connect( actionForward, SIGNAL( triggered() ), this, SLOT( slot_forward() ) );
	
	actionBackward= new QAction( QIcon( ":/backward.png" ), tr("&backward"), this );
	actionBackward->setShortcut( QKeySequence( tr( "Ctrl+b" ) ) );
	connect( actionBackward, SIGNAL( triggered() ), this, SLOT( slot_backward() ) );
	
	actionNext= new QAction( QIcon( ":/next.png" ), tr("&next"), this );
	actionNext->setShortcut( QKeySequence( tr( "Ctrl+n" ) ) );
	connect( actionNext, SIGNAL( triggered() ), this, SLOT( slot_next() ) );
	
	actionPrevious= new QAction( QIcon( ":/previous.png" ), tr("&previous"), this );
	actionPrevious->setShortcut( QKeySequence( tr( "Ctrl+p" ) ) );
	connect( actionPrevious, SIGNAL( triggered() ), this, SLOT( slot_previous() ) );


	actionReinitAudio= new QAction( QIcon( ":/reinitAudio.png" ), tr("reinit audio"), this );
	actionReinitAudio->setShortcut( QKeySequence( tr( "Ctrl+i" ) ) );
	connect( actionReinitAudio, SIGNAL( triggered() ), this, SLOT( slot_reinitAudio() ) );


	actionFullScreen= new QAction( QIcon( ":/fullscreen.png" ), tr("fullscreen"), this );
	actionFullScreen->setShortcut( QKeySequence( tr( "Alt+Enter" ) ) );
	connect( actionFullScreen, SIGNAL( triggered() ), this, SLOT( slot_toggleFullScreen() ) );

	actionVideoOptions= new QAction( QIcon( ":/options.png" ), tr("&videoOptions"), this );
	actionVideoOptions->setShortcut( QKeySequence( tr( "F11" ) ) );
	connect( actionVideoOptions, SIGNAL( triggered() ), this, SLOT( slot_toggleVideoOptions() ) );


	audioInfoBox->addAction( actionStart );
	audioInfoBox->addAction( actionPause );
	audioInfoBox->addAction( actionStop );
	audioInfoBox->addAction( actionBackward );
	audioInfoBox->addAction( actionForward );
	audioInfoBox->addAction( actionRepeat );
	//audioInfoBox->addAction( actionReplay );
	audioInfoBox->addAction( actionNext );
	audioInfoBox->addAction( actionPrevious );
	
	if (toolbar) {
	 	toolbar->addAction( actionPrevious );
 		toolbar->addSeparator();	
 		toolbar->addAction( actionStart );
 		toolbar->addAction( actionPause );
 		toolbar->addAction( actionStop );
 		toolbar->addSeparator();	
 		toolbar->addAction( actionNext );
 		toolbar->addSeparator();	
		toolbar->addWidget( volumeSlider );
		toolbar->addSeparator();	
//		toolbar->addAction( actionBackward );
//		toolbar->addAction( actionForward );
//		toolbar->addSeparator();	
//		toolbar->addAction( actionRepeat );
		//toolbar->addAction( actionReplay );
		//toolbar->addSeparator();	
		toolbar->addSeparator();	
		toolbar->addAction( actionReinitAudio );
		toolbar->addAction( actionVideoOptions );
		
		if (!aspectRatioComboBox) { 
			aspectRatioComboBox= new QComboBox( toolbar );
			aspectRatioComboBox->setMinimumSize( 125, aspectRatioComboBox->minimumSize().height() );
			aspectRatioComboBox->resize( 125, 18 );

			aspectRatioComboBox->addItem( "Automatisch" );
			aspectRatioComboBox->addItem( "Fenster" );
			aspectRatioComboBox->addItem( "4:3" );
			aspectRatioComboBox->addItem( "16:9" );
		
			toolbar->addWidget( aspectRatioComboBox );
			connect( aspectRatioComboBox, SIGNAL( activated( int ) ), this, SLOT( slot_aspectComboIndexChanged( int ) ) );
		}
	}


}

/**************************************************************************//**
\brief  initVideoOptionsPanel - 


\return  - 
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "initVideoOptionsPanel"

/**************************************************************************//**
\brief  initVideoOptionsPanel - 
*******************************************************************************
\brief  default - 



\param  parent - 
*******************************************************************************
\return  - 
******************************************************************************/

::QWidget *OMediaPlayer :: initVideoOptionsPanel (::QWidget *parent )
{

	if (videoOptionsPanel) {
		return videoOptionsPanel;
	}
	videoOptionsPanel= new QWidget( parent );
	
	sliderBrightness= new QSlider( videoOptionsPanel );
	sliderBrightness->setOrientation( Qt::Horizontal );
	sliderBrightness->setRange( 0, 200 );
	connect( sliderBrightness, SIGNAL( valueChanged( int ) ), this, SLOT( voSlot_brightness( int ) ) );
	
	sliderHue= new QSlider( videoOptionsPanel );
	sliderHue->setOrientation( Qt::Horizontal );
	sliderHue->setRange( 0, 200 );
	connect( sliderHue, SIGNAL( valueChanged( int ) ), this, SLOT( voSlot_hue( int ) ) );

	sliderContrast= new QSlider( videoOptionsPanel );
	sliderContrast->setOrientation( Qt::Horizontal );
	sliderContrast->setRange( 0, 200 );
	connect( sliderContrast, SIGNAL( valueChanged( int ) ), this, SLOT( voSlot_contrast( int ) ) );

	sliderSaturation= new QSlider( videoOptionsPanel );
	sliderSaturation->setOrientation( Qt::Horizontal );
	sliderSaturation->setRange( 0, 200 );
	connect( sliderSaturation, SIGNAL( valueChanged( int ) ), this, SLOT( voSlot_saturation( int ) ) );

	QGridLayout *layout = new QGridLayout();
	layout->setSpacing( 0 );
	layout->setContentsMargins( 0, 0, 0, 0 );

	layout->addWidget( new QLabel( "Helligkeit", videoOptionsPanel ), 0, 0 );
	layout->addWidget( sliderBrightness, 1, 0 );
	layout->addWidget( new QLabel( "Kontrast", videoOptionsPanel ), 0, 1 );
	layout->addWidget( sliderContrast, 1, 1 );
	layout->addWidget( new QLabel( "Farbe", videoOptionsPanel ), 2, 0 );
	layout->addWidget( sliderHue, 3, 0 );
	layout->addWidget( new QLabel( "Sttigung", videoOptionsPanel ), 2, 1 );
	layout->addWidget( sliderSaturation, 3, 1 );

//	layout->addLayout( layout_time );

//	layout_time->addSpacing( 3 );
	
	videoOptionsPanel->setLayout( layout );
	
	videoOptionsPanel->hide();
	return videoOptionsPanel;
}

/**************************************************************************//**
\brief  moSlot_aboutToFinish - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "moSlot_aboutToFinish"

/**************************************************************************//**
\brief  moSlot_aboutToFinish - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: moSlot_aboutToFinish ( )
{

BEGINSEQ
  if ( busy )                                       LEAVESEQ
  
  busy= true;
  control_handle->message("next");
  busy= false;

ENDSEQ

}

/**************************************************************************//**
\brief  moSlot_metaDataChanged - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "moSlot_metaDataChanged"

/**************************************************************************//**
\brief  moSlot_metaDataChanged - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: moSlot_metaDataChanged ( )
{
	QString text= "";
	QStringList md;
	try {
    	md= mediaObject->metaData( Phonon::ArtistMetaData );
    	if (md.length() > 0 && md.at( 0 ).trimmed() != "") {
    		text+= "<b>Interpret:</b> " + md.at( 0 ) + "<br>";
    	} else {
    		text+= "<b>Interpret:</b><br>";
    	}
    	
    	md= mediaObject->metaData( Phonon::AlbumMetaData );
    	if (md.length() > 0 && md.at( 0 ).trimmed() != "") {
    		text+= "<b>Album:</b> " + md.at( 0 ) + "<br>";
    	} else {
    		text+= "<b>Album:</b><br>";
    	}
    
    	md= mediaObject->metaData( Phonon::TitleMetaData );
    	if (md.length() > 0 && md.at( 0 ).trimmed() != "") {
    		text+= "<b>Titel:</b> " + md.at( 0 ) + "<br>";
    	} else {
    		text+= "<b>Titel:</b><br>";
    	}
    
    	md= mediaObject->metaData( Phonon::DateMetaData );
    
    	md= mediaObject->metaData( Phonon::GenreMetaData );
    	if (md.length() > 0 && md.at( 0 ).trimmed() != "") {
    		text+= "<b>Genre:</b> " + md.at( 0 ) + "<br>";
    	} else {
    		text+= "<b>Genre:</b><br>";
    	}
    
    	md= mediaObject->metaData( Phonon::TracknumberMetaData );
    	if (md.length() > 0 && md.at( 0 ).trimmed() != "") {
    		text+= "<b>Titel Nr.:</b> " + md.at( 0 ) + "<br>";
    	} else {
    		text+= "<b>Titel Nr.:</b><br>";
    	}
    
    	md= mediaObject->metaData( Phonon::DescriptionMetaData );
	} catch (...) {
		audioInfoBox->setText( "---" );
		return;
	}

	audioInfoBox->setText( text );

}

/**************************************************************************//**
\brief  moSlot_stateChanged - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "moSlot_stateChanged"

/**************************************************************************//**
\brief  moSlot_stateChanged - 
*******************************************************************************
\brief  default - 



\param  oldPhononState - 
\param  newPhononState - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: moSlot_stateChanged (Phonon::State oldPhononState, Phonon::State newPhononState )
{

  if ( newPhononState == Phonon::ErrorState ) {
    int x= mediaObject->errorType();
    QString tmp= mediaObject->errorString();
    tmp = "";
    return;
  }
  if ( newPhononState != Phonon::StoppedState && newPhononState != Phonon::PausedState ) return;
  if ( mediaObject->currentSource().type() == Phonon::MediaSource::Invalid ) return;
	
  QMap<QString, QString> metaData = mediaObject->metaData();
	
  QString title= metaData.value("TITLE");
  if ( title == "" ) {
    title = mediaObject->currentSource().fileName();
  }
	
  QString artistItem = metaData.value( "ARTIST" );
  QString albumItem = metaData.value( "ALBUM" );
  QString yearItem = metaData.value( "DATE");

  //Phonon::MediaSource source = metaInformationResolver->currentSource();

}

/**************************************************************************//**
\brief  moSlot_tick - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "moSlot_tick"

/**************************************************************************//**
\brief  moSlot_tick - 
*******************************************************************************
\brief  default - 



\param  qi64Time - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: moSlot_tick (qint64 qi64Time )
{

 refreshProgressLabel(*labelTime_position, qi64Time);

}

/**************************************************************************//**
\brief  moSlot_totalTimeChanged - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "moSlot_totalTimeChanged"

/**************************************************************************//**
\brief  moSlot_totalTimeChanged - 
*******************************************************************************
\brief  default - 



\param  qi64Time - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: moSlot_totalTimeChanged (qint64 qi64Time )
{

  refreshProgressLabel(*labelTime_length, qi64Time);

}

/**************************************************************************//**
\brief  refreshProgressLabel - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "refreshProgressLabel"

/**************************************************************************//**
\brief  refreshProgressLabel - 
*******************************************************************************
\brief  default - 



\param  rQLabel - 
\param  qi64Time - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: refreshProgressLabel (QLabel &rQLabel, qint64 qi64Time )
{
  QString time= "";
  int hour= qi64Time / 3600000;
  int min= (qi64Time - (hour * 3600000)) / 60000;
  int sec= (qi64Time - (hour * 3600000) - (min * 60000)) / 1000;
	
  if ( hour < 10 ) {
    time+= "0";
  }
  time+= QString::number( hour );
	
  time+= ":";
	
  if ( min < 10 ) {
    time+= "0";
  }
  time+= QString::number(min);
	
  time+= ":";
	
  if ( sec < 10 ) {
    time+= "0";
  }
  time+= QString::number(sec);


  rQLabel.setText(time);

}

/**************************************************************************//**
\brief  slot_aspectComboIndexChanged - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_aspectComboIndexChanged"

/**************************************************************************//**
\brief  slot_aspectComboIndexChanged - 
*******************************************************************************
\brief  default - 



\param  pos - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_aspectComboIndexChanged (int pos )
{

  switch ( pos ) {
    case 1:
      videoWidget->setAspectRatio( Phonon::VideoWidget::AspectRatioWidget );
      break;
    case 2:
      videoWidget->setAspectRatio( Phonon::VideoWidget::AspectRatio4_3 );
      break;
    case 3:
      videoWidget->setAspectRatio( Phonon::VideoWidget::AspectRatio16_9 );
      break;
    default:
      videoWidget->setAspectRatio( Phonon::VideoWidget::AspectRatioAuto );
      break;
  }


}

/**************************************************************************//**
\brief  slot_backward - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_backward"

/**************************************************************************//**
\brief  slot_backward - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_backward ( )
{



}

/**************************************************************************//**
\brief  slot_forward - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_forward"

/**************************************************************************//**
\brief  slot_forward - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_forward ( )
{



}

/**************************************************************************//**
\brief  slot_next - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_next"

/**************************************************************************//**
\brief  slot_next - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_next ( )
{

  control_handle->message("next");

}

/**************************************************************************//**
\brief  slot_pause - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_pause"

/**************************************************************************//**
\brief  slot_pause - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_pause ( )
{

  mediaObject->pause();

}

/**************************************************************************//**
\brief  slot_previous - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_previous"

/**************************************************************************//**
\brief  slot_previous - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_previous ( )
{

  control_handle->message("previous");

}

/**************************************************************************//**
\brief  slot_reinitAudio - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_reinitAudio"

/**************************************************************************//**
\brief  slot_reinitAudio - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_reinitAudio ( )
{

  audioPath.disconnect();
	
  if ( audioOutput ) {
    volumeSlider->setAudioOutput(0);	
    delete audioOutput;
    audioOutput= 0;
  }
  audioOutput= new Phonon::AudioOutput(Phonon::MusicCategory, this);
  audioPath.reconnect(mediaObject, audioOutput);
  volumeSlider->setAudioOutput(audioOutput);

}

/**************************************************************************//**
\brief  slot_repeat - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_repeat"

/**************************************************************************//**
\brief  slot_repeat - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_repeat ( )
{



}

/**************************************************************************//**
\brief  slot_start - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_start"

/**************************************************************************//**
\brief  slot_start - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_start ( )
{

  mediaObject->play();

}

/**************************************************************************//**
\brief  slot_stop - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_stop"

/**************************************************************************//**
\brief  slot_stop - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_stop ( )
{

  mediaObject->stop();

}

/**************************************************************************//**
\brief  slot_toggleFullScreen - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_toggleFullScreen"

/**************************************************************************//**
\brief  slot_toggleFullScreen - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_toggleFullScreen ( )
{

  if ( videoWidget->isVisible() ) {
    fullscreen= !fullscreen;
    videoWidget->setFullScreen(fullscreen);
  }

}

/**************************************************************************//**
\brief  slot_toggleVideoOptions - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_toggleVideoOptions"

/**************************************************************************//**
\brief  slot_toggleVideoOptions - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OMediaPlayer :: slot_toggleVideoOptions ( )
{

  if ( videoOptionsPanel->isVisible() ) {
    videoOptionsPanel->hide();
  } else {
    sliderBrightness->setSliderPosition(videoWidget->brightness() * 100 + 100);
    sliderContrast->setSliderPosition(videoWidget->contrast() * 100 + 100);
    sliderHue->setSliderPosition(videoWidget->hue() * 100 + 100);
    sliderSaturation->setSliderPosition(videoWidget->saturation() * 100 + 100);
    videoOptionsPanel->show();
  }

}

/**************************************************************************//**
\brief  startFile - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "startFile"

/**************************************************************************//**
\brief  startFile - 
*******************************************************************************
\brief  default - 



\param  rcQString - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: startFile (const ::QString &rcQString )
{
  QFileInfo fi( rcQString );
  if ( fi.exists() ) {
    if ( fi.suffix() == "mp3" || fi.suffix() == "ogg" || fi.suffix() == "wma" ) {
      videoWidget->hide();
      audioInfoBox->show();
    } else {
      if (!videoWidget->isVisible()) {
        fullscreen= false;
      }
      videoWidget->show();
      audioInfoBox->hide();
      videoWidget->setFullScreen( fullscreen );
    }
    mediaObject->setCurrentSource( Phonon::MediaSource( fi.absoluteFilePath() ) );
    mediaObject->play();
  }

}

/**************************************************************************//**
\brief  voSlot_brightness - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "voSlot_brightness"

/**************************************************************************//**
\brief  voSlot_brightness - 
*******************************************************************************
\brief  default - 



\param  iPosition - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: voSlot_brightness (int iPosition )
{

  videoWidget->setBrightness(((qreal)(iPosition - 100)) / 100);

}

/**************************************************************************//**
\brief  voSlot_contrast - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "voSlot_contrast"

/**************************************************************************//**
\brief  voSlot_contrast - 
*******************************************************************************
\brief  default - 



\param  iPosition - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: voSlot_contrast (int iPosition )
{

  videoWidget->setContrast(((qreal)(iPosition - 100)) / 100);

}

/**************************************************************************//**
\brief  voSlot_hue - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "voSlot_hue"

/**************************************************************************//**
\brief  voSlot_hue - 
*******************************************************************************
\brief  default - 



\param  iPosition - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: voSlot_hue (int iPosition )
{

  videoWidget->setHue(((qreal)(iPosition - 100)) / 100);

}

/**************************************************************************//**
\brief  voSlot_saturation - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "voSlot_saturation"

/**************************************************************************//**
\brief  voSlot_saturation - 
*******************************************************************************
\brief  default - 



\param  iPosition - 
*******************************************************************************
******************************************************************************/

void OMediaPlayer :: voSlot_saturation (int iPosition )
{

  videoWidget->setSaturation(((qreal)(iPosition - 100)) / 100);

}

/**************************************************************************//**
\brief  widget - 


\return pQWidget - 
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "widget"

/**************************************************************************//**
\brief  widget - 
*******************************************************************************
\brief  i0 - 



*******************************************************************************
\return pQWidget - 
******************************************************************************/

::QWidget *OMediaPlayer :: widget ( )
{

  return panel;

}

/**************************************************************************//**
\brief  ~OMediaPlayer - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "~OMediaPlayer"

/**************************************************************************//**
\brief  ~OMediaPlayer - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

     OMediaPlayer :: ~OMediaPlayer ( )
{

  delete audioOutput;	
  mediaObject->stop();
  delete mediaObject;

}


