/********************************* Class Declaration ***************************/
/**
\package  _uc_Uml - 
\class    UmlView (Build: 93)

\brief    UML View
          Displays the class hierarchy as UML Diagram using Graphviz

\date     $Date: 2011-10-26 13:55:02.89 $
\note     dbsource gui.dev - ODABA Version 11.2.0

          Copyright (C) 1994-2011 Run Software GmbH.
 
          This program is free software: you can redistribute it and/or modify
          it under the terms of the GNU General Public License as published by
          the Free Software Foundation, either version 3 of the License, or
          (at your option) any later version.
 
          This program is distributed in the hope that it will be useful,
          but WITHOUT ANY WARRANTY; without even the implied warranty of
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
          GNU General Public License 3.0 for more details.
 
          You should have received a copy of the GNU General Public License
          along with this program. If not, see <http://www.gnu.org/licenses/>.

*/
/******************************************************************************/
#pragma once
class UmlView;

class QLabel;
class QWidget;
class UmlSettingsDialog;
#include  <h/ImageWidget.hpp>
#include  <h/cqt.h>
#include  <h/cqt.h>
class  UmlView    : public QScrollArea                                       ,
public UserControl                                       
{


private    :                                                       Q_OBJECT;                                                 // 
private    :         ::QWidget                                   * display;                                                  // 
private    :         ImageWidget                                 * uml;                                                      // 
private    :         QLabel                                      * error_label;                                              // 
private    :         UmlSettingsDialog                           * settings;                                                 // 
private    :         QTextEdit                                   * source;                                                   // 
private    :         QStackedLayout                              * stack_layout;                                             // 

public     :
public     :                                       void Initialize ( );
public     :                                       void SetupContextMenu ( );
public     :                                            UmlView (UserControlHandle *pUserControlHandle, ::QWidget *pQWidget );
public     :  virtual                              void drawDot (::QString qsValue );
public     :  virtual                              void fillData ( );
public     :  public slots:                        void slotPrint ( );
public     :  public slots:                        void slotRedraw ( );
public     :  public slots:                        void slotSave ( );
public     :  public slots:                        void slotSettings ( );
public     :  public slots:                        void slotSource ( );
public     :  virtual                              ::QWidget *widget ( );
public     :                                            ~UmlView ( );

};

