/********************************* Class Source Code ***************************/
/**
\package  _uc_Uml - 
\class    UmlSettingsDialog (Build: 58)

\brief    


\date     $Date: 2011-10-26 13:55:08.04 $
\note     dbsource gui.dev - ODABA Version 11.2.0

          Copyright (C) 1994-2011 Run Software GmbH.
 
          This program is free software: you can redistribute it and/or modify
          it under the terms of the GNU General Public License as published by
          the Free Software Foundation, either version 3 of the License, or
          (at your option) any later version.
 
          This program is distributed in the hope that it will be useful,
          but WITHOUT ANY WARRANTY; without even the implied warranty of
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
          GNU General Public License 3.0 for more details.
 
          You should have received a copy of the GNU General Public License
          along with this program. If not, see <http://www.gnu.org/licenses/>.

*/
/******************************************************************************/
#define    OBJ_ID  "UmlSettingsDialog"

#include  <h/p_uc_Uml.h>
#include  <h/cqt.h>
#include  <h/UmlSettingsDialog.moc>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/UmlView.hpp>
#include  <h/UmlSettingsDialog.hpp>


















/**************************************************************************//**
\brief  UmlSettingsDialog - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "UmlSettingsDialog"

/**************************************************************************//**
\brief  UmlSettingsDialog - 
*******************************************************************************
\brief  default - 



\param  pUmlView - 
*******************************************************************************
******************************************************************************/

     UmlSettingsDialog :: UmlSettingsDialog (UmlView *pUmlView )
                     : QWidget(pUmlView),
  uml(pUmlView),
  layout(NULL),
  ok(NULL),
  cancel(NULL),
  depth_basing_on(NULL),
  depth_based_on(NULL),
  post_expression(NULL),
  show_based_on(NULL),
  show_basing_on(NULL),
  show_functions(NULL),
  show_member(NULL),
  show_referenced_classes(NULL),
  show_referencing_classes(NULL),
  show_referenced_member(NULL),
  show_referencing_member(NULL),
  size(NULL)
{
  QLabel *l;
  int row = 0;
  layout = new QGridLayout(this);
  
  show_basing_on = new QCheckBox(this);
  l = new QLabel(this); l->setText("Show basing on");
  layout->addWidget(l,row,0);
  layout->addWidget(show_basing_on,row,1);
  row++;
  
  depth_basing_on = new QSpinBox(this);
  l = new QLabel(this); l->setText("Depth basing on");
  layout->addWidget(l,row,0);
  layout->addWidget(depth_basing_on,row,1);
  row++;
  
  show_based_on = new QCheckBox(this);
  l = new QLabel(this); l->setText("Show based on");
  layout->addWidget(l,row,0);
  layout->addWidget(show_based_on,row,1);
  row++;

  depth_based_on = new QSpinBox(this);
  l = new QLabel(this); l->setText("Depth based on");
  layout->addWidget(l,row,0);
  layout->addWidget(depth_based_on,row,1);
  row++;

  size = new QLineEdit(this);
  l = new QLabel(this); l->setText("Size in inch");
  layout->addWidget(l,row,0);
  layout->addWidget(size,row,1);
  row++;
  
  show_functions = new QCheckBox(this);
  l = new QLabel(this); l->setText("Functions");
  layout->addWidget(l,row,0);
  layout->addWidget(show_functions,row,1);
  row++;

  show_member = new QCheckBox(this);
  l = new QLabel(this); l->setText("Member");
  layout->addWidget(l,row,0);
  layout->addWidget(show_member,row,1);
  row++;
  
  show_referenced_classes = new QCheckBox(this);
  show_referenced_classes->setVisible(false);
  //Not Yet Implemented
  //l = new QLabel(this); l->setText("Referenced Classes");
  //layout->addWidget(l,row,0);
  //layout->addWidget(show_referenced_classes,row,1);
  //row++;
  
  show_referencing_classes = new QCheckBox(this);
  l = new QLabel(this); l->setText("Referencing Classes");
  layout->addWidget(l,row,0);
  layout->addWidget(show_referencing_classes,row,1);
  row++;
  
  show_referencing_member = new QCheckBox(this);
  l = new QLabel(this); l->setText("Referencing Member");
  layout->addWidget(l,row,0);
  layout->addWidget(show_referencing_member,row,1);
  row++;
  
  show_referenced_member = new QCheckBox(this);
  show_referenced_member->setVisible(false);
  //l = new QLabel(this); l->setText("Referenced Member");
  //layout->addWidget(l,row,0);
  //layout->addWidget(show_referenced_member,row,1);
  //row++;

  post_expression = new QTextEdit(this);
  post_expression->setVisible(false);
  //l = new QLabel(this); l->setText("Post Expression");
  //layout->addWidget(l,row,0,1,3);
  //row++;
  //layout->addWidget(post_expression,row,0,1,3);row++;
  
  ok = new QPushButton(this);
  ok->setText("Ok");
  layout->addWidget(ok,row,2);
  connect(ok,SIGNAL(clicked()),this,SLOT(slotOK()));
  
  cancel = new QPushButton(this);
  cancel->setText("Cancel");
  layout->addWidget(cancel,row,3);
  connect(cancel,SIGNAL(clicked()),this,SLOT(slotCancel()));
  
  loadSettings();


}

/**************************************************************************//**
\brief  loadSettings - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "loadSettings"

/**************************************************************************//**
\brief  loadSettings - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void UmlSettingsDialog :: loadSettings ( )
{
  odaba::String s;
  QString       qs;
  depth_basing_on->setValue(odaba::Option("Options.Documentation.Graph.DepthBasingOn").toInteger());
  depth_based_on->setValue(odaba::Option("Options.Documentation.Graph.DepthBasedOn").toInteger());
  s  = odaba::Option("Options.Documentation.Graph.Size").toString().toUTF16();
  size->setText(QString::fromUtf16(s.data16()));
  s = odaba::Option("Options.Documentation.Graph.PostExpression").toString().toUTF16();
  post_expression->setText(QString::fromUtf16(s.data16()));
  show_based_on->setCheckState(odaba::Option("Options.Documentation.Graph.ShowBasedOn").isTrue() ? Qt::Checked : Qt::Unchecked);
  show_basing_on->setCheckState(odaba::Option("Options.Documentation.Graph.ShowBasingOn").isTrue() ? Qt::Checked : Qt::Unchecked);
  show_functions->setCheckState(odaba::Option("Options.Documentation.Graph.ShowFunctions").isTrue() ? Qt::Checked : Qt::Unchecked);
  show_member->setCheckState(odaba::Option("Options.Documentation.Graph.ShowMember").isTrue() ? Qt::Checked : Qt::Unchecked);
  show_referenced_classes->setCheckState(odaba::Option("Options.Documentation.Graph.ShowReferencedClasses").isTrue() ? Qt::Checked : Qt::Unchecked);
  show_referencing_classes->setCheckState(odaba::Option("Options.Documentation.Graph.ShowReferencingClasses").isTrue() ? Qt::Checked : Qt::Unchecked);
  show_referenced_member->setCheckState(odaba::Option("Options.Documentation.Graph.ShowReferencedMember").isTrue() ? Qt::Checked : Qt::Unchecked);
  show_referencing_member->setCheckState(odaba::Option("Options.Documentation.Graph.ShowReferencingMember").isTrue() ? Qt::Checked : Qt::Unchecked);
  
  storeSettings(); // initializes the options for the first time;

}

/**************************************************************************//**
\brief  slotCancel - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slotCancel"

/**************************************************************************//**
\brief  slotCancel - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void UmlSettingsDialog :: slotCancel ( )
{

  loadSettings();
  uml->slotRedraw();

}

/**************************************************************************//**
\brief  slotOK - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slotOK"

/**************************************************************************//**
\brief  slotOK - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void UmlSettingsDialog :: slotOK ( )
{

  storeSettings();
  uml->fillData();
  uml->slotRedraw();

}

/**************************************************************************//**
\brief  storeSettings - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "storeSettings"

/**************************************************************************//**
\brief  storeSettings - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void UmlSettingsDialog :: storeSettings ( )
{
odaba::String s;

  s = (int64)depth_basing_on->value();
  odaba::Option("Options.Documentation.Graph.DepthBasingOn") = s;
  s = (int64)depth_based_on->value();
  odaba::Option("Options.Documentation.Graph.DepthBasedOn") = s;
  s = odaba::String(size->text().utf16(), odaba::UTF16String);
  odaba::Option("Options.Documentation.Graph.Size") = s;
  s = odaba::String(post_expression->toPlainText().utf16(), odaba::UTF16String);
  odaba::Option("Options.Documentation.Graph.PostExpression") = s;
  s = show_based_on->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowBasedOn") = s;
  s = show_basing_on->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowBasingOn") = s;
  s = show_functions->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowFunctions") = s;
  s = show_member->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowMember") = s;
  s = show_referenced_classes->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowReferencedClasses") = s;
  s = show_referencing_classes->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowReferencingClasses") = s;
  s = show_referencing_member->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowReferencingMember") = s;
  s = show_referenced_member->checkState()==Qt::Checked ? "YES" : "NO";
  odaba::Option("Options.Documentation.Graph.ShowReferencedMember") = s;

}

/**************************************************************************//**
\brief  ~UmlSettingsDialog - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "~UmlSettingsDialog"

/**************************************************************************//**
\brief  ~UmlSettingsDialog - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

     UmlSettingsDialog :: ~UmlSettingsDialog ( )
{



}


