/********************************* Class Source Code ***************************/
/**
\package  _uc_WebView - 
\class    OWEBControl (Build: 270)

\brief    


\date     $Date: 2011-10-10 20:07:50.23 $
\note     dbsource gui.dev - ODABA Version 11.2.0

          Copyright (C) 1994-2011 Run Software GmbH.
 
          This program is free software: you can redistribute it and/or modify
          it under the terms of the GNU General Public License as published by
          the Free Software Foundation, either version 3 of the License, or
          (at your option) any later version.
 
          This program is distributed in the hope that it will be useful,
          but WITHOUT ANY WARRANTY; without even the implied warranty of
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
          GNU General Public License 3.0 for more details.
 
          You should have received a copy of the GNU General Public License
          along with this program. If not, see <http://www.gnu.org/licenses/>.

*/
/******************************************************************************/
#define    OBJ_ID  "OWEBControl"

#include  <UserControls/_uc_WebView/h/p_uc_WebView.h>
#include  <UserControls/_uc_WebView/h/icons.rcc>
#include  <iostream>
#include  <UserControls/_uc_WebView/h/OWEBControl.moc>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <h/cqt.h>
#include  <UserControls/_uc_WebView/h/Sleep.hpp>
#include  <ogui/h/UserControlHandle.hpp>
#include  <UserControls/_uc_WebView/h/OWEBControl.hpp>














/**************************************************************************//**
\brief  OWEBControl - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "OWEBControl"

/**************************************************************************//**
\brief  OWEBControl - 
*******************************************************************************
\brief  default - 



\param  pUserControlHandle - 
\param  parent - 
*******************************************************************************
******************************************************************************/

     OWEBControl :: OWEBControl (UserControlHandle *pUserControlHandle, QWidget *parent )
                     : 	UserControl( pUserControlHandle )
	, OHTMLControlBase( false )
{

	toolbar= 0;
	historyComboBox= 0;
	
	panel= new QWidget( parent );
	webView= new QWebView( panel );
	panel->setFocusProxy( webView );


	QObject::connect( webView, SIGNAL( linkClicked( const QUrl ) ), 
			this, SLOT( ohact_urlClicked( const QUrl ) ) );
			
	QObject::connect( webView, SIGNAL( loadFinished( bool ) ), 
			this, SLOT( slot_loadFinished( bool ) ) );
	QObject::connect( webView, SIGNAL( loadStarted() ), 
			this, SLOT( slot_loadStarted() ) );
			

	actionForward= new QAction( QIcon( ":/arrow_next.png" ), tr("&next"), this );
	actionForward->setShortcuts( QKeySequence::Forward );
	connect( actionForward, SIGNAL( triggered() ), this, SLOT( ohact_HistoryNext() ) );
	
	actionBackward= new QAction( QIcon( ":/arrow_prev.png" ), tr("&previous"), this );
	actionBackward->setShortcuts( QKeySequence::Back );
	connect( actionBackward, SIGNAL( triggered() ), this, SLOT( ohact_HistoryPrevious() ) );
	
	actionReload= new QAction( QIcon( ":/reload.png" ), tr("&reload"), this );
	actionReload->setShortcuts( QKeySequence::Refresh );
	connect( actionReload, SIGNAL( triggered() ), this, SLOT( ohact_Refresh() ) );

	actionZoomIn= new QAction( QIcon( ":/zoom_in.png" ), tr("zoomIn (Ctrl++)"), this );
	actionZoomIn->setShortcuts( QKeySequence::ZoomIn );
	connect( actionZoomIn, SIGNAL( triggered() ), this, SLOT( slot_zoomIn() ) );

	actionZoomOut= new QAction( QIcon( ":/zoom_out.png" ), tr("zoomOut (Ctrl+-)"), this );
	actionZoomOut->setShortcuts( QKeySequence::ZoomOut );
	connect( actionZoomOut, SIGNAL( triggered() ), this, SLOT( slot_zoomOut() ) );

	actionZoomDefault= new QAction( QIcon( ":/zoom_default.png" ), tr("zoomDefault (Ctrl+0)"), this );
	actionZoomDefault->setShortcut( QKeySequence( tr( "Ctrl+0" ) ) );
	connect( actionZoomDefault, SIGNAL( triggered() ), this, SLOT( slot_zoomDefault() ) );

	pageIsLoading= false;
	
	webView->addAction( actionBackward );
	webView->addAction( actionForward );
	webView->addAction( actionReload );
	webView->addAction( actionZoomIn );
	webView->addAction( actionZoomOut );
	webView->addAction( actionZoomDefault );
	
	webView->setFocusPolicy( Qt::WheelFocus );
	
	layout = new QVBoxLayout();
	layout->setSpacing( 0 );
	layout->setContentsMargins( 0, 0, 0, 0 );
	
	ProvideToolBar();
	layout->addWidget( webView );
	panel->setLayout( layout );

}

/**************************************************************************//**
\brief  ProvideToolBar - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ProvideToolBar"

/**************************************************************************//**
\brief  ProvideToolBar - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: ProvideToolBar ( )
{

BEGINSEQ
	if (toolbar)                                    LEAVESEQ
  
	toolbar= new QToolBar( panel );
	toolbar->resize( 400, 24 );
	toolbar->setIconSize( QSize( 18, 18 ) );
  
	if (!historyComboBox) { 
		historyComboBox= new QComboBox( toolbar );
		historyComboBox->setMinimumSize( 300, historyComboBox->minimumSize().height() );
		historyComboBox->resize( 225, 18 );

		ohact_initHistoryComboBox( *historyComboBox );
		
		toolbar->addWidget( historyComboBox );
		connect( historyComboBox, SIGNAL( activated( int ) ), 
				this, SLOT( ohact_historyComboIndexChanged( int ) ) );
	}

	toolbar->addAction( actionBackward );
	toolbar->addAction( actionForward );
	toolbar->addAction( actionReload );
	toolbar->addSeparator();	
	toolbar->addAction( actionZoomOut );
	toolbar->addAction( actionZoomIn );
	toolbar->addAction( actionZoomDefault );


	toolbar->show();
	//layout->insertWidget( 0, toolbar );
	layout->addWidget( toolbar );
	//layout->update();

ENDSEQ

}

/**************************************************************************//**
\brief  RemoveToolBar - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "RemoveToolBar"

/**************************************************************************//**
\brief  RemoveToolBar - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: RemoveToolBar ( )
{

BEGINSEQ
	if (!toolbar)                                     LEAVESEQ

	layout->setMenuBar( toolbar );
	layout->update();
	toolbar->setVisible( false );

	delete historyComboBox;
	historyComboBox = NULL;

	delete toolbar;
	toolbar = NULL;

ENDSEQ

}

/**************************************************************************//**
\brief  activate - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "activate"

/**************************************************************************//**
\brief  activate - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: activate ( )
{



}

/**************************************************************************//**
\brief  clearData - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "clearData"

/**************************************************************************//**
\brief  clearData - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: clearData ( )
{

 	ohact_FillData( QString() );

}

/**************************************************************************//**
\brief  deactivate - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "deactivate"

/**************************************************************************//**
\brief  deactivate - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: deactivate ( )
{



}

/**************************************************************************//**
\brief  fillData - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "fillData"

/**************************************************************************//**
\brief  fillData - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: fillData ( )
{

	if (!get_control_handle()) return;
	if (!get_control_handle()->property()) return;
	
	odaba::Property prop( *get_control_handle()->property() );
	QString value;
	try {
		value = static_cast<const char *>(prop.value().toString().area());
	} catch (...) {
	}
	ohact_FillData( value );

}

/**************************************************************************//**
\brief  ohev_beforeSetUrl - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohev_beforeSetUrl"

/**************************************************************************//**
\brief  ohev_beforeSetUrl - 
*******************************************************************************
\brief  default - 



\param  rcQString - 
\param  link - 
*******************************************************************************
******************************************************************************/

void OWEBControl :: ohev_beforeSetUrl (const QString &rcQString, const QUrl &link )
{

	odaba::Property prop( *get_control_handle()->property() );
	try {
		prop.value()= rcQString.toAscii().data();
	} catch (...) {
	}

}

/**************************************************************************//**
\brief  ohget_documentTitle - 


\return  - 
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohget_documentTitle"

/**************************************************************************//**
\brief  ohget_documentTitle - 
*******************************************************************************
\brief  default - 



*******************************************************************************
\return  - 
******************************************************************************/

const QString OWEBControl :: ohget_documentTitle ( )
{

	if (pageIsLoading) {
		return "loading...";
	} else {
		return webView->title();
	}

}

/**************************************************************************//**
\brief  ohget_historyComboBox - 


\return  - 
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohget_historyComboBox"

/**************************************************************************//**
\brief  ohget_historyComboBox - 
*******************************************************************************
\brief  default - 



*******************************************************************************
\return  - 
******************************************************************************/

QComboBox *OWEBControl :: ohget_historyComboBox ( )
{


	return historyComboBox;
}

/**************************************************************************//**
\brief  ohrea_addResourcePath - 


\return  - 
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohrea_addResourcePath"

/**************************************************************************//**
\brief  ohrea_addResourcePath - 
*******************************************************************************
\brief  0_QString - 



\param  resourcePath - 
*******************************************************************************
\return  - 
******************************************************************************/

void OWEBControl :: ohrea_addResourcePath (const QString &resourcePath )
{



}

/**************************************************************************//**
\brief  ohrea_removeResourcePath - 


\return term - Termination code
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohrea_removeResourcePath"

/**************************************************************************//**
\brief  ohrea_removeResourcePath - 
*******************************************************************************
\brief  i00 - 



\param  resourcePath - 
*******************************************************************************
\return term - Termination code
******************************************************************************/

bool OWEBControl :: ohrea_removeResourcePath (const QString &resourcePath )
{


	return true;
}

/**************************************************************************//**
\brief  ohrea_resourcePathExists - 


\return  - 
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohrea_resourcePathExists"

/**************************************************************************//**
\brief  ohrea_resourcePathExists - 
*******************************************************************************
\brief  default - 



\param  resourcePath - 
*******************************************************************************
\return  - 
******************************************************************************/

bool OWEBControl :: ohrea_resourcePathExists (const QString &resourcePath )
{


  return true;
}

/**************************************************************************//**
\brief  ohrea_scrollToAnchor - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohrea_scrollToAnchor"

/**************************************************************************//**
\brief  ohrea_scrollToAnchor - 
*******************************************************************************
\brief  default - 



\param  resourcePath - 
*******************************************************************************
******************************************************************************/

void OWEBControl :: ohrea_scrollToAnchor (const QString &resourcePath )
{
	QUrl url;

	url.setFragment( resourcePath );
	webView->setUrl( url );

}

/**************************************************************************//**
\brief  ohrea_setHtml - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohrea_setHtml"

/**************************************************************************//**
\brief  ohrea_setHtml - 
*******************************************************************************
\brief  default - 



\param  rcQString - 
\param  baseUrl - 
*******************************************************************************
******************************************************************************/

void OWEBControl :: ohrea_setHtml (const QString &rcQString, const QUrl &baseUrl )
{

	if (baseUrl == emptyUrl) {
		if (rcQString != "") {
			webView->setHtml( rcQString );
		} else {
			webView->setHtml( "" );
		}
	} else {
		ohrea_setSource( baseUrl );
	}

}

/**************************************************************************//**
\brief  ohrea_setPlainText - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohrea_setPlainText"

/**************************************************************************//**
\brief  ohrea_setPlainText - 
*******************************************************************************
\brief  default - 



\param  rcQString - 
\param  baseUrl - 
*******************************************************************************
******************************************************************************/

void OWEBControl :: ohrea_setPlainText (const QString &rcQString, const QUrl &baseUrl )
{

	webView->setContent( rcQString.toUtf8(), "text/plain", baseUrl );

}

/**************************************************************************//**
\brief  ohrea_setSource - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "ohrea_setSource"

/**************************************************************************//**
\brief  ohrea_setSource - 
*******************************************************************************
\brief  default - 



\param  link - 
*******************************************************************************
******************************************************************************/

void OWEBControl :: ohrea_setSource (const QUrl &link )
{

	webView->load( link );

}

/**************************************************************************//**
\brief  propertyActivated - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "propertyActivated"

/**************************************************************************//**
\brief  propertyActivated - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: propertyActivated ( )
{



}

/**************************************************************************//**
\brief  propertyClosed - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "propertyClosed"

/**************************************************************************//**
\brief  propertyClosed - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: propertyClosed ( )
{



}

/**************************************************************************//**
\brief  propertyOpened - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "propertyOpened"

/**************************************************************************//**
\brief  propertyOpened - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: propertyOpened ( )
{



}

/**************************************************************************//**
\brief  slot_loadFinished - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_loadFinished"

/**************************************************************************//**
\brief  slot_loadFinished - 
*******************************************************************************
\brief  default - 



\param  bState - 
*******************************************************************************
******************************************************************************/

void OWEBControl :: slot_loadFinished (bool bState )
{

	pageIsLoading= false;
	
	if (webView->page()->linkDelegationPolicy() != QWebPage::DelegateAllLinks) {
		webView->page()->setLinkDelegationPolicy( QWebPage::DelegateAllLinks );
	}

	if (!bState) {
		QString tmpStr;
		html_getErrorString( "loading failed", tmpStr );
		webView->setHtml( tmpStr );
	}
	ohact_loadingFinished( bState );

}

/**************************************************************************//**
\brief  slot_loadStarted - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_loadStarted"

/**************************************************************************//**
\brief  slot_loadStarted - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: slot_loadStarted ( )
{

	pageIsLoading= true;

}

/**************************************************************************//**
\brief  slot_zoomDefault - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_zoomDefault"

/**************************************************************************//**
\brief  slot_zoomDefault - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: slot_zoomDefault ( )
{

	webView->setZoomFactor( 1 );

}

/**************************************************************************//**
\brief  slot_zoomIn - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_zoomIn"

/**************************************************************************//**
\brief  slot_zoomIn - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: slot_zoomIn ( )
{

	webView->setZoomFactor( webView->zoomFactor () * 1.2 );

}

/**************************************************************************//**
\brief  slot_zoomOut - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "slot_zoomOut"

/**************************************************************************//**
\brief  slot_zoomOut - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

void OWEBControl :: slot_zoomOut ( )
{

	webView->setZoomFactor( webView->zoomFactor () / 1.2 );

}

/**************************************************************************//**
\brief  widget - 


\return  - 
******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "widget"

/**************************************************************************//**
\brief  widget - 
*******************************************************************************
\brief  default - 



*******************************************************************************
\return  - 
******************************************************************************/

QWidget *OWEBControl :: widget ( )
{

	return panel;// dynamic_cast<QWidget*>( dynamic_cast<QScrollArea*>( webView ) );

}

/**************************************************************************//**
\brief  ~OWEBControl - 


******************************************************************************/
#undef     MOD_ID
#define    MOD_ID  "~OWEBControl"

/**************************************************************************//**
\brief  ~OWEBControl - 
*******************************************************************************
\brief  default - 



*******************************************************************************
******************************************************************************/

     OWEBControl :: ~OWEBControl ( )
{



}


